<?php
/*
Plugin Name: Pretty Simple Progress meter
Plugin URI: http://www.dev.micklauer.com/?p=5
Description: A super simple progress meter for tracking the progress of anything!
Author: Mick Lauer, RicePirate
Version: 1.0
Author URI: http://artistupgrade.com/artistupgrade-tourist-about.php
License: GPL2

    Copyright 2010  Mick Lauer  (email : mick@artistupgrade.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2, 
    as published by the Free Software Foundation. 
    
    You may NOT assume that you can use any other version of the GPL.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    The license for this software can likely be found here: 
    http://www.gnu.org/licenses/gpl-2.0.html
    
*/
add_action('wp_head', 'psp_css');    
	function psp_css() {
	echo ' ' . "\n";
	echo '<!-- Pretty Simple Progress Styles, YAR -->' . "\n";
	echo '<link type="text/css" rel="stylesheet" href="' . get_bloginfo('wpurl') .'/wp-content/plugins/pretty-simple-progress-meter/css/psp_styles.php" />' . "\n";
	echo ' ' . "\n";
	}





class Pretty_Simple_Progress_Widget extends WP_Widget {


	function Pretty_Simple_Progress_Widget() {
		$widget_ops = array('classname' => 'widget_prettysimpleprogress', 'description' => __('Adds a super simple progress tracker. So pretty!'));
		$control_ops = array('width' => 400, 'height' => 350);
		$this->WP_Widget('prettysimpleprogress', __('Pretty Simple Progress <?php echo $text ?>' ), $widget_ops, $control_ops);
	}

	function widget( $args, $instance ) {
		extract($args);
//		$title = apply_filters( 'widget_title', empty($instance['text']) ? '' : $instance['text'], $instance );
		$title = apply_filters( 'widget_prettysimpleprogress', $instance['title'], $instance );
		$detail = apply_filters( 'widget_prettysimpleprogress', $instance['detail'], $instance );
		$pspUnit = apply_filters( 'widget_prettysimpleprogress', $instance['unit'], $instance );
		$pspGoal = apply_filters( 'widget_prettysimpleprogress', $instance['goal'], $instance );
		$pspCurrent = apply_filters( 'widget_prettysimpleprogress', $instance['current'], $instance );		
		$hideIcon = apply_filters( 'widget_prettysimpleprogress', $instance['hideIcon'], $instance );
		
		$custom = apply_filters( 'widget_prettysimpleprogress', $instance['custom'], $instance );
		$pspIcon = apply_filters( 'widget_prettysimpleprogress', $instance['icon'], $instance );
 	
 	
  		$total = ($pspCurrent / $pspGoal)*100;
		echo $before_widget;
//		if ( !empty( $title ) ) { echo $before_title . $title . $after_title; } 
			ob_start();
			eval('?>'.$title);
			$title = ob_get_contents();
			ob_end_clean();
			?>			
			<div class="prettysimpleprogresswidget"><div class="<?php echo $hideIcon; ?>"><img src="<?php echo $pspIcon; ?>" class="pspImg" title="<?php echo $text; ?>" /></div>
				<div class="pspDescription"><?php echo $title; ?></div>
				<div class="pspDetail"><?php echo $detail; ?></div>
				<div class="pspMeter">
							<div class="pspBar" style="width:<?php echo $total; ?>%"></div>
				</div>
				<div class="pspProgress"><?php echo $pspCurrent; ?> <i>of</i> <?php echo $pspGoal; ?> <i><?php echo $pspUnit; ?></i></div>
			</div>
		<?php
		echo $after_widget;
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
//		$instance['title'] = strip_tags($new_instance['title']);

		if ( current_user_can('unfiltered_html') )
			$instance['title'] =  $new_instance['title'];
		else
			$instance['title'] = stripslashes( wp_filter_post_kses( $new_instance['title'] ) );

		if ( current_user_can('unfiltered_html') )
			$instance['detail'] =  $new_instance['detail'];
		else
			$instance['detail'] = stripslashes( wp_filter_post_kses( $new_instance['detail'] ) );
			
		if ( current_user_can('unfiltered_html') )
			$instance['custom'] =  $new_instance['custom'];
		else
			$instance['custom'] = stripslashes( wp_filter_post_kses( $new_instance['custom'] ) );
									
		$instance['unit'] = strip_tags($new_instance['unit']);
		$instance['goal'] = strip_tags($new_instance['goal']);
		$instance['current'] = strip_tags($new_instance['current']);
		$instance['icon'] = strip_tags($new_instance['icon']);
		$instance['hideIcon'] = strip_tags($new_instance['hideIcon']);
		$instance['filter'] = isset($new_instance['filter']);
		return $instance;
	}

	function form( $instance ) {
		$instance = wp_parse_args( (array) $instance, array( 'title' => '', 'detail' => '', 'unit' => '', 'goal' => '', 'current' => '' , 'custom' => '') );
//		$title = strip_tags($instance['title']);
		$title = format_to_edit($instance['title']);
		$custom = format_to_edit($instance['custom']);
		$detail = format_to_edit($instance['detail']);
		$pspCurrent = strip_tags($instance['current']);
		$pspGoal = strip_tags($instance['goal']);
		$pspUnit = strip_tags($instance['unit']);
		$pspIcon = strip_tags($instance['icon']);
		$hideIcon = strip_tags($instance['hideIcon']);
?>

	<p style="font: 16px Arial; color:#247ca4;">Description</p>
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label>
		<input  id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" 
		size="30" /></p>
		
		<p><label for="<?php echo $this->get_field_id('text'); ?>"><?php _e('Details:'); ?></label>
		<input id="<?php echo $this->get_field_id('detail'); ?>" name="<?php echo $this->get_field_name('detail'); ?>" type="text" value="<?php echo esc_attr($detail); ?>" 
		size="30" /></p>
		
	<p style="font: 16px Arial; color:#247ca4; border-top:1px solid #ccc;margin-top:20px; padding-top:10px;">Progress</p>
		<p>Current <input id="<?php echo $this->get_field_id('current'); ?>" name="<?php echo $this->get_field_name('current'); ?>" type="text" value="<?php echo esc_attr($pspCurrent); ?>" size="6" />
		&nbsp; &nbsp; Goal
		<input id="<?php echo $this->get_field_id('goal'); ?>" name="<?php echo $this->get_field_name('goal'); ?>" type="text" value="<?php echo esc_attr($pspGoal); ?>" size="6" />
		<i style="color:#aaa;">Use Only Integers!</i>
		</p>
				
 		<p>Units
		<input id="<?php echo $this->get_field_id('unit'); ?>" name="<?php echo $this->get_field_name('unit'); ?>" type="text" value="<?php echo esc_attr($pspUnit); ?>" 
		size="20"/>
		</p>

	<p style="font: 16px Arial; color:#247ca4; border-top:1px solid #ccc;margin-top:20px; padding-top:10px;">Icon Options</p>

		<p>
		Select Icon
		<select name="<?php echo $this->get_field_name('icon'); ?>" width="100" style="width: 100px">
		<option value="/wp-content/plugins/pretty-simple-progress-meter/psp-star.png" <?php selected('/wp-content/plugins/pretty-simple-progress-meter/psp-star.png', $instance["icon"]); ?>>Star</option>
		<option value="/wp-content/plugins/pretty-simple-progress-meter/psp-clock.png" <?php selected('/wp-content/plugins/pretty-simple-progress-meter/psp-clock.png', $instance["icon"]); ?>>Clock</option>
		<option value="/wp-content/plugins/pretty-simple-progress-meter/psp-pages.png" <?php selected('/wp-content/plugins/pretty-simple-progress-meter/psp-pages.png', $instance["icon"]); ?>>Pages</option>
		<option value="/wp-content/plugins/pretty-simple-progress-meter/psp-book.png" <?php selected('/wp-content/plugins/pretty-simple-progress-meter/psp-book.png', $instance["icon"]); ?>>Book</option>
		<option value="/wp-content/plugins/pretty-simple-progress-meter/psp-money.png" <?php selected('/wp-content/plugins/pretty-simple-progress-meter/psp-money.png', $instance["icon"]); ?>>Money</option>
		<option value="/wp-content/plugins/pretty-simple-progress-meter/psp-happy.png" <?php selected('/wp-content/plugins/pretty-simple-progress/psp-happy.png', $instance["icon"]); ?>>Smiley</option>
		<option value="<?php echo $custom; ?>" <?php selected( $custom,$instance["icon"]); ?>>Custom</option>
		</select>
		
		&nbsp; &nbsp; On/Off Switch
		<select name="<?php echo $this->get_field_name('hideIcon'); ?>" width="70" style="width: 70px">
		<option value="show" <?php selected('show', $instance["hideIcon"]); ?>>Show</option>
		<option value="hide" <?php selected('hide', $instance["hideIcon"]); ?>>Hide</option>
		</select>
		

		</p>
		
		<p>Custom Img URL
		<input id="<?php echo $this->get_field_id('custom'); ?>" name="<?php echo $this->get_field_name('custom'); ?>" type="text" value="<?php echo esc_attr($custom); ?>" 
		size="36"/></p>
		
<?php
	}
}

add_action('widgets_init', create_function('', 'return register_widget("Pretty_Simple_Progress_Widget");'));
add_action('admin_menu', 'psp_create_menu');

function psp_create_menu() {

	//create new top-level menu
	add_menu_page('Simple Progress Tracker Plugin Settings', 'Pretty Simple Progress', 'administrator', __FILE__, 'psp_settings_page',plugins_url('icon.png', __FILE__));

	//call register settings function
	add_action( 'admin_init', 'register_pspsettings' );
}


function register_pspsettings() {
	//register our settings
	register_setting( 'psp-settings-group', 'background_color' );
	register_setting( 'psp-settings-group', 'meter_color' );
	register_setting( 'psp-settings-group', 'bar_thick' );	
	register_setting( 'psp-settings-group', 'title_color' );
	register_setting( 'psp-settings-group', 'detail_color' );
	register_setting( 'psp-settings-group', 'progress_color' );
	register_setting( 'psp-settings-group', 'minor_color' );
 	register_setting( 'psp-settings-group', 'height_option' );
	register_setting( 'psp-settings-group', 'width_option' );
 }

function psp_settings_page() {
 	$backgroundOption = get_option('background_color');
 	$backgroundOption = ($backgroundOption == "") ? 'ddd' : $backgroundOption;
 	$meterOption = get_option('meter_color');
 	$meterOption = ($meterOption == "") ? 'f00' : $meterOption;
 	$titleOption = get_option('title_color');
 	$titleOption = ($titleOption == "") ? '333' : $titleOption;
 	$detailOption = get_option('detail_color');
 	$detailOption = ($detailOption == "") ? '777' : $detailOption;
 	$progressOption = get_option('progress_color');
 	$progressOption = ($progressOption == "") ? 'aaa' : $progressOption;
 	$minorOption = get_option('minor_color');
 	$minorOption = ($minorOption == "") ? 'ccc' : $minorOption;

 	$thickOption = get_option('bar_thick');
 	$thickOption = ($thickOption == "") ? '10' : $thickOption;
 	$heightOption = get_option('height_option');
 	$heightOption = ($heightOption == "") ? '30' : $heightOption;
 	$widthOption = get_option('width_option');
 	$widthOption = ($widthOption == "") ? '30' : $widthOption;
?>

<div class="wrap">
<h2 style="margin-bottom:0; padding-bottom:0;">Pretty Simple Progress meter</h2>
<h4 style="margin-top:0; padding-top:8px; font-weight:normal;">Productivity widget pieced together by <a href="http://www.artistupgrade.com/artistupgrade-tourist-about.php" target="_blank">Mick Lauer</a><i>(aka RicePirate)</i> &mdash; <a href="http://dev.micklauer.com" target="_blank">Pretty Simple Stuff</a></h4>
<p>&nbsp;</p>
<h4 style="margin-top:0; padding-top:8px; font-weight:normal;">For all color values, please use <a href="http://www.w3schools.com/Html/html_colors.asp" target="_blank">CSS-friendly hexidecimal color numbers</a>.  No pound (#) needed.</h4>
<form method="post" action="options.php">
    <?php settings_fields( 'psp-settings-group' ); ?>
    <table class="form-table">
        <tr valign="top">
        <th scope="row">Meter Background Color</th>
        <td>#<input type="text" maxlength="6" name="background_color" size="6"
        value="<?php echo $backgroundOption ; ?>" /> 
        </td>
        </tr>
         
        <tr valign="top">
        <th scope="row">Current Progress Color</th>
        <td>#<input type="text" maxlength="6" name="meter_color" size="6"
        value="<?php echo $meterOption ; ?>" /> 
        </td>
        </tr>

        <tr valign="top">
        <th scope="row">Title Color</th>
        <td>#<input type="text" maxlength="6" name="title_color" size="6"
        value="<?php echo $titleOption ; ?>" /> 
        </td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Details Color</th>
        <td>#<input type="text" maxlength="6" name="detail_color" size="6"
        value="<?php echo $detailOption ; ?>" /> 
        </td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Progress Counter Color</th>
        <td>#<input type="text" maxlength="6" name="progress_color" size="6"
        value="<?php echo $progressOption ; ?>" /> 
        </td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Progress Counter (detail) Color</th>
        <td>#<input type="text" maxlength="6" name="minor_color" size="6"
        value="<?php echo $minorOption ; ?>" /> 
        </td>
        </tr>

        <tr valign="top">
        <th scope="row">Bar Thickness</th>
        <td><input type="text" name="bar_thick" maxlength="4" size="3"
        value="<?php echo $thickOption ; ?>" />px</td>
        </tr>        
                        
        <tr valign="top">
        <th scope="row">Icon Height</th>
        <td><input type="text" name="height_option" maxlength="4" size="3"
        value="<?php echo $heightOption ; ?>" />px</td>
        </tr>        
                        
        <tr valign="top">
        <th scope="row">Icon Width</th>
        <td><input type="text" name="width_option" maxlength="4"  size="3"
        value="<?php echo $widthOption ; ?>" />px</td>
        </tr>        
                        
         <tr valign="top">
        <th scope="row">Preview</th>
        <td>
        
        
               
        
        <div style="padding:0;margin:10px 0 0 0;width:300px;">
        <div style="width:<?php echo $widthOption ; ?>px;height:<?php echo $heightOption ; ?>px;padding:0;margin:2px 6px 0 0;float:left;background-color:#<?php echo $meterOption ; ?>;"><img
        src="/wp-content/plugins/pretty-simple-progress-meter/psp-star.png" style="width:<?php echo $widthOption ; ?>px;height:<?php echo $heightOption ; ?>px;padding:0;margin:0;" /></div>
 		<div style="font:bold 14px 'Century Gothic',Verdana, Arial;color:#<?php echo $titleOption ; ?>;margin:0;padding:0 0 0px 0;float:none;">My Meter Preview</div>
		<div style="font:10px Verdana;color:#<?php echo $detailOption ; ?>;margin:0;padding:0 0 6px 0;float:none;">Avast! This thang is rox0r</div>
		<div style="background-color:#<?php echo $backgroundOption; ?>;width:300px;margin:0;padding:0;height:<?php echo $thickOption; ?>px;">
							<p style="background-color:#<?php echo $meterOption ; ?>;width:130px;margin:0;padding:0;height:<?php echo $thickOption; ?>px;"></p>

		</div>
		<div style="text-align:right;font:10px Helvetica, Arial;color:#<?php echo $progressOption ; ?>;margin:0;padding:4px 0 0 0;">379 <i style="color:#<?php echo $minorOption ; ?>;font-style:normal;">of</i> 403 <i style="color:#<?php echo $minorOption ; ?>;font-style:normal;">joy nuggets</i></div>
			</div>
        
</td>
        </tr>
        
       
      
    </table>
    
    <p class="submit">
    <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
    </p>

</form>


    <table class="form-table" style="border-top:1px solid #ccc;">

          <tr valign="top">
        <th scope="row">Showing Support</th>
        <td><p>If you love this widget, and would like to send a donation of any amount ... I won't stop you.  In fact, I'll do a <a href="http://www.youtube.com/watch?v=WRHNsZFH-cU" target="_blank">dance of joy!</a></p>      
  <form action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_blank">
<input type="hidden" name="cmd" value="_s-xclick">
<input type="hidden" name="hosted_button_id" value="YSAUMWQPMXF64">
<input type="image" src="https://www.paypal.com/en_US/i/btn/btn_donate_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
<img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1">
</form>
   </td>
   </tr>
      
    </table>
</div>
<?php } ?>
